/*
    \brief Datei beinhaltet alle Defines die von der API benötigt werden.

    \author Bernd Ottmann
    \date   21.02.2003

    \note Um die API-Version einzustellen und damit die zur Verfügung stehenden Funktionen anzupassen /sa DF_API_VERSION
*/
#pragma once
#ifndef DATAFOX_DEFINES_H
#ifndef DOXYGEN_SHOULD_SKIP_THIS
    #define DATAFOX_DEFINES_H
#endif

/*!
    \brief Version der verwendeten DLL.

    \todo Version der verwendeten DLL pruefen, um nur die enthaltenen Routinen zu
    importieren oder auch zu exportieren.
*/
#define DF_API_VERSION          0x04030800

// Eventuell fehlende typedefs ersetzen
#if defined(_MSC_VER) || defined(__MINGW32__)
    #ifndef HANDLE
        typedef void* HANDLE;
    #endif
#else
    #ifndef HANDLE
        typedef int HANDLE;
    #endif
#endif

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +------------+ EXPORTIERTE FUNKTIONEN +----------------+
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//! \def DF_API_EXTERN_DECORATE Gibt den Praefix fuer Funktionen an. (Dekorierung und Export-, Importangabe)

#ifdef DF_API_EXTERN
    #undef DF_API_EXTERN
#endif

#if defined(_MSC_VER) || defined(__MINGW32__)

    #ifdef __MINGW32__
        #define DF_API_EXTERN_DECORATE     extern "C" __attribute__ ((visibility ("default")))
        #define DF_API_EXTERN              extern "C" __attribute__ ((visibility ("default")))
        #define DF_API_CALL
        #if defined( DF_API_EXPORT )
            // Einzubindende Bibliotheken: Version.lib, WSock32.lib
            // DllGetVersion
            #ifndef WIN32_LEAN_AND_MEAN
                #define WIN32_LEAN_AND_MEAN
            #endif
            #include "shlwapi.h"
        #endif
    #else
        #if defined( DF_API_EXPORT )
            // Einzubindende Bibliotheken: Version.lib, WSock32.lib
            #define DF_API_EXTERN_DECORATE     extern "C" __declspec(dllexport)
            // DllGetVersion
            #ifndef WIN32_LEAN_AND_MEAN
                #define WIN32_LEAN_AND_MEAN
            #endif
            #include "shlwapi.h"
        #else
            #define DF_API_EXTERN_DECORATE     extern "C" __declspec(dllimport)
        #endif

        #define DF_API_EXTERN                  extern "C"
        #define DF_API_CALL                    __stdcall

    #endif

#else

    #define DF_API_EXTERN_DECORATE         extern "C" __attribute__ ((visibility ("default"))) 
    #define DF_API_EXTERN                  extern "C" __attribute__ ((visibility ("default"))) 
    #define DF_API_CALL

#endif

#endif
